# distutils: language = c++

# Cython interface file for wrapping the object
#
#

from libcpp.vector cimport vector
from libcpp cimport bool

# c++ interface to cython
cdef extern from "dots_asa.h" :
  cdef vector[double] depth(
          vector[vector[double]] &,
          vector[double] &,
          vector[vector[double]] &,
          double,
          double,
          vector[double] &,
          vector[double] &,
          bool)
  cdef vector[double] depth2(
          vector[vector[double]] &,
          vector[vector[double]] &,
          vector[vector[double]] &,
          double,
          double)
  cdef vector[double] asa_dots(
          vector[vector[double]] &,
          vector[double] &,
          vector[vector[double]] &,
          double,
          bool)

# creating a cython wrapper class
# plane_o, plane_n:
# (1) if specified, dection dot (d) is kept if (d - o) * n > 0 
# (2) if not specified, it will be ignored
def dots_depth(xyz, r, sample_dots, probe, dist, plane_o=[], plane_n=[], remove_interior_cavities=False):
    raw = depth(xyz, r, sample_dots, probe, dist, plane_o, plane_n, remove_interior_cavities)
    return [x-probe for x in raw]

def dots_depth2(ca_xyz, xyz, sample_dots, probe, dist):
    raw = depth2(ca_xyz, xyz, sample_dots, probe, dist)
    return [x-probe for x in raw]

def dots_asa(xyz, r, sample_dots, probe, remove_interior_cavities=False):
    return asa_dots(xyz, r, sample_dots, probe, remove_interior_cavities)
