# Cython compile instructions

from distutils.core import Extension
from distutils.core import setup
from Cython.Build import cythonize

# Use python setup.py build_ext --inplace to compile

ext_modules = [
    Extension("_wrap_dots_asa",
    sources=["./dots_asa/_wrap_dots_asa.pyx", "./dots_asa/dots_asa.cpp"],
    language="c++",
    extra_compile_args=["-std=c++14", "-Ilib"],
    extra_link_args=["-std=c++14", "-Ilib"],
    )
]

setup(
  name = "hb_lib",
  package_dir = {'': './'},
  ext_modules = cythonize(ext_modules),
)
